AddCSLuaFile("cl_init.lua")
AddCSLuaFile("shared.lua")
include('shared.lua')

function ENT:Activate()

end

function ENT:Freeze()
	self.Entity:SetMoveType(MOVETYPE_NONE)
end

function ENT:Explode()
	local Ent = ents.Create("env_explosion")
	Ent:SetPos(self.Entity:GetPos())
	Ent:Spawn()
	Ent:Activate()
	Ent:SetKeyValue("iMagnitude", 20)
	Ent:SetKeyValue("iRadiusOverride", 400)
	Ent:Fire("explode", "", 0)
	
	for i = 1, 10 do
		local Cluster = ents.Create("sent_cluster")
		
		Cluster:SetModel("models/props/cs_italy/orange.mdl")
		Cluster:SetPos(self.Entity:GetPos())
		Cluster:Spawn()
		util.SpriteTrail(Cluster, 0, Color(100, 100, 100), false, 20, 1, 4, 1/(15 + 1) * 0.5, "trails/smoke.vmt")
		
		local Phys = Cluster:GetPhysicsObject()
		
		if Phys:IsValid() then
			Phys:Wake()
			Phys:ApplyForceCenter(Vector(math.random(5-500, 500), math.random(5-500, 500), math.random(5-500, 500)) * Phys:GetMass())
		end
	end
	
	self.Entity:Fire("kill", "", "0.2")
end

function ENT:OnRemove()
end

function ENT:Think()
	
end

function ENT:OnTakeDamage(Dmg)
end

function ENT:Initialize()
	self.Entity:SetModel("models/combine_helicopter/helicopter_bomb01.mdl")
	self.Entity:PhysicsInit(SOLID_VPHYSICS)
	self.Entity:SetMoveType(MOVETYPE_VPHYSICS)
	self.Entity:SetSolid(SOLID_VPHYSICS)

	local Phys = self.Entity:GetPhysicsObject()
	if Phys:IsValid() then
		Phys:Wake()
	end
	
	timer.Simple(2, self.Explode, self)
end